/*
 * 
 * ________________________________________________________________

                   USING NOTIFY ICONS & GOOGLE SEARCH STRINGS

                                              Ron Kessler

                                        Created 11/10/2014
________________________________________________________________

Updated 11/12/2014 Final testing

Add a notifyicon component from the toolbox.
Look closely at the properties for the notifyicon.


When you run this app. make sure to resize VS a little so you can see the task bar. When you type
in a search string, a little balloon will appear for about 2 secs in the System Tray and you will see
a search icon. 

I use a property to hold the search string instead of a class-level variable.
 */


#pragma once

namespace NotificationBaloon_CPP {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	//---add this so we can query process running on the computer
	using namespace System::Diagnostics;
	
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			this->CenterToScreen();
		}

#pragma region Generated Stuff
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	internal: System::Windows::Forms::Button^  btnQuit;
	protected: 
	internal: System::Windows::Forms::NotifyIcon^  NotifyIcon1;


	internal: System::Windows::Forms::TextBox^  txtSearch;
	internal: System::Windows::Forms::Label^  Label1;

	internal: System::Windows::Forms::Button^  btnSearch;

	internal: 
	private: System::ComponentModel::IContainer^  components;
	internal: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>

#pragma endregion

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
		this->components = (gcnew System::ComponentModel::Container());
		System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
		this->btnQuit = (gcnew System::Windows::Forms::Button());
		this->NotifyIcon1 = (gcnew System::Windows::Forms::NotifyIcon(this->components));
		this->txtSearch = (gcnew System::Windows::Forms::TextBox());
		this->Label1 = (gcnew System::Windows::Forms::Label());
		this->btnSearch = (gcnew System::Windows::Forms::Button());
		this->SuspendLayout();
		// 
		// btnQuit
		// 
		this->btnQuit->Location = System::Drawing::Point(311, 130);
		this->btnQuit->Margin = System::Windows::Forms::Padding(4);
		this->btnQuit->Name = L"btnQuit";
		this->btnQuit->Size = System::Drawing::Size(100, 28);
		this->btnQuit->TabIndex = 9;
		this->btnQuit->Text = L"Quit";
		this->btnQuit->UseVisualStyleBackColor = true;
		this->btnQuit->Click += gcnew System::EventHandler(this, &Form1::btnQuit_Click);
		// 
		// NotifyIcon1
		// 
		this->NotifyIcon1->BalloonTipText = L"Program is searching....";
		this->NotifyIcon1->BalloonTipTitle = L"Ron\'s Google Search";
		this->NotifyIcon1->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"NotifyIcon1.Icon")));
		this->NotifyIcon1->Text = L"Using Notify Icons Demo";
		this->NotifyIcon1->Visible = true;
		// 
		// txtSearch
		// 
		this->txtSearch->Location = System::Drawing::Point(244, 59);
		this->txtSearch->Margin = System::Windows::Forms::Padding(4);
		this->txtSearch->Name = L"txtSearch";
		this->txtSearch->Size = System::Drawing::Size(188, 22);
		this->txtSearch->TabIndex = 7;
		// 
		// Label1
		// 
		this->Label1->AutoSize = true;
		this->Label1->Location = System::Drawing::Point(47, 62);
		this->Label1->Margin = System::Windows::Forms::Padding(4, 0, 4, 0);
		this->Label1->Name = L"Label1";
		this->Label1->Size = System::Drawing::Size(178, 17);
		this->Label1->TabIndex = 10;
		this->Label1->Text = L"Enter Internet Search Text:";
		// 
		// btnSearch
		// 
		this->btnSearch->Location = System::Drawing::Point(187, 130);
		this->btnSearch->Margin = System::Windows::Forms::Padding(4);
		this->btnSearch->Name = L"btnSearch";
		this->btnSearch->Size = System::Drawing::Size(100, 28);
		this->btnSearch->TabIndex = 8;
		this->btnSearch->Text = L"Search";
		this->btnSearch->UseVisualStyleBackColor = true;
		this->btnSearch->Click += gcnew System::EventHandler(this, &Form1::btnSearch_Click);
		// 
		// Form1
		// 
		this->AcceptButton = this->btnSearch;
		this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
		this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
		this->ClientSize = System::Drawing::Size(526, 226);
		this->Controls->Add(this->btnQuit);
		this->Controls->Add(this->txtSearch);
		this->Controls->Add(this->Label1);
		this->Controls->Add(this->btnSearch);
		this->Name = L"Form1";
		this->Text = L"Using Notification Ballons";
		this->ResumeLayout(false);
		this->PerformLayout();

			}
#pragma endregion

		//**********Start of my Code*********

#pragma region Properties

		  private: String^ _String2Find;
               
		public: property String^ SearchString
	    {
		    String^ get()
            {
                return _String2Find;
            }
		    void set(String^ value)
            {
                _String2Find = value;
            }
	    }

#pragma endregion
		
	private: System::Void btnSearch_Click(System::Object^  sender, System::EventArgs^  e) 
				 {
				            this->SearchString = txtSearch->Text->Trim();

							if ( this->SearchString->Trim()->Length > 0)
							{
							    //---2000= 2000ms = 2 sec. But it doesn't matter in C++/CLI. The O/S handles this.	
							    NotifyIcon1->ShowBalloonTip(2000);    
								Process^ launchApp = gcnew Process();
								launchApp->StartInfo->FileName = ("http://www.google.com/search?q=" + this->SearchString + "&rls=com.microsoft:en-us&ie=UTF-8&oe=UTF-8&startIndex=&startPage=1");
								launchApp->Start();
                
							}
				 }
				private: void CloseAll()
							 {
									NotifyIcon1->Visible = false;
									
									//---now find all the instances of IE that are running-> You can use this for any program!
									array<Process^>^ theProcesses = System::Diagnostics::Process::GetProcessesByName("Iexplore");

									//---cycle through them and find the one where my search string shows up in the IE title bar
									//---I am searching a string to find where 'Iexplore' is. It returns an integer which indicates the
									//    first position in the string being searched where it found a match.
									//    If the value is >0 then it found it. If IE is running 5 times it will close all instances of IE.

									for each (Process^ currentProcess in theProcesses)
										{

											int position = currentProcess->MainWindowTitle->IndexOf(this->SearchString);
											if (position >= 0 )
												currentProcess->Kill();
                   
										}
										Application::Exit();         //close
    
								}



     private: System::Void btnQuit_Click(System::Object^  sender, System::EventArgs^  e) 
				  {
                       CloseAll();
			 
				  }
};
}

